/*
stores data obtained from USASpending.gov in an easy to access format
*/
class SpendingData {
  public String dept;
  public int fiscalYear;
  public float totalObligation;
  public float totalPercent;
  public int numContractors;
  public int numTransactions;

  public NameAmt[] topProducts = new NameAmt[5];
  public NameAmt[] topAgencies = new NameAmt[5];
  public NameAmt[] topContractors = new NameAmt[10];

  public float yPosTop;
  public float yPosBottom;
  public float xPosLeft;
  public float xPosRight;
  public color col;
  public String toString() {
    String rtn = "";
    rtn += (dept+" - "+fiscalYear)+"\n";
    rtn += "\t$"+totalObligation + " = " + totalPercent + "\n"; 
    rtn += ("\tTop Products:")+"\n";
    for(int i = 0; i < topProducts.length; i++) {
      rtn += ("\t\t"+topProducts[i])+"\n";
    }
    rtn += ("\tTop Agencies:")+"\n";
    for(int i = 0; i < topAgencies.length; i++) {
      if(topAgencies[i] == null) {
        continue;
      }
      rtn += ("\t\t"+topAgencies[i])+"\n";
    }
    rtn += ("\tTop Contractors:")+"\n";
    for(int i = 0; i < topContractors.length; i++) {
      rtn += ("\t\t"+topContractors[i])+"\n";
    }
    return rtn;
  }
}
class SpendingDataComparator implements Comparator {
  public int compare(Object o1, Object o2) {
    SpendingData s1 = (SpendingData) o1;
    SpendingData s2 = (SpendingData) o2;
    return int(s2.totalObligation - s1.totalObligation);
  }
}
class NameAmtComparator implements Comparator {
  public int compare(Object o1, Object o2) {
    NameAmt s1 = (NameAmt) o1;
    NameAmt s2 = (NameAmt) o2;
    return int(s2.amnt - s1.amnt);
  }
}
class NameAmt {
  public float amnt;
  public String name; 
  public String dept;
  public String toString() {
   return name + ": $"+amnt + " ("+dept+")";
  } 
}


